components/accounts/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls import url
from django.urls import reverse
from .views import UserCreationView, activate, EditUserProfileView, ChangePasswordPage, PasswordChangeView, PasswordResetView, SetNewPasswordView, LoginView, resend_email_verification_link, PasswordResetCompleteView
from django.contrib.auth import views as auth_views
from django.contrib.auth.decorators import login_required
from .forms import ForgotPasswordForm, SetNewPasswordForm, ChangePasswordForm, LoginForm
from django.views.generic.base import TemplateView

app_name= 'account'

urlpatterns = [
    path('registration/', UserCreationView.as_view(), name='sign-up'),
    path('confirm-email/<uidb64>/<token>/<secret_token>', activate, name='activate'),
    path('login/', LoginView.as_view(redirect_authenticated_user=True,), name="sign-in"),
    path('logout/', auth_views.LogoutView.as_view(next_page='account:sign-in'), name="logout"),
    path('profile/edit', login_required(EditUserProfileView.as_view()), name="profile"),
	path('password/change', login_required(PasswordChangeView.as_view(template_name="change-password.html", form_class=ChangePasswordForm), login_url='account:sign-in'), name='change-password'),
	path('password/change/done/', login_required(auth_views.PasswordChangeDoneView.as_view(template_name="change-password-done.html")), name='change-password-done'),
    path('password/reset/', PasswordResetView.as_view(template_name='password-reset.html', form_class=ForgotPasswordForm, email_template_name='password-reset-email.html'), name="forgot-password"),
    path('password/reset/email/done',auth_views.PasswordResetDoneView.as_view(template_name="password-reset-email-done-message.html"), name="password_reset_done"),
    path('password/reset/confirm/<uidb64>/<token>',SetNewPasswordView.as_view(template_name="set-new-password.html", form_class=SetNewPasswordForm), name='password_reset_confirm'),
    path('password/reset/complete/', PasswordResetCompleteView.as_view(template_name="password-reset-complete.html"), name="password_reset_complete"),
    path('request/status', TemplateView.as_view(template_name="message-handler.html"), name="message_handler"),
    path('resend/confirm-email/<username>', resend_email_verification_link , name='resend_confirm_email'),
]

try:
    from .views import LostTwoFactorAuthDevice
    urlpatterns.append(path('lost-device/', LostTwoFactorAuthDevice.as_view(), name="lost_device"))
except:
    pass

components/base/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import TemplateView

app_name= 'base'

urlpatterns = [
    path('', TemplateView.as_view(template_name="home.html"), name='base_page'),
]

components/components/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.staticfiles.urls import static
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from . import settings

handler404 = 'base.views.handler404'

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('base.urls')),
    path('accounts/', include('accounts.urls')),
    path('predict/', include('image_process.urls')),
    path('', include('portfolio.urls')),
    path('', include('contact_us.urls')),
    path('', include('two_factor_authentication.urls'))
]

#urlpatterns += staticfiles_urlpatterns()
#urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

components/two_factor_authentication/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth.views import LoginView
from django_otp.forms import OTPAuthenticationForm
from .views import TwoFactorAuthentication, RegisterTwoFactorAuthentication, DisableTwoFactorAuthentication, qrcode_view, RecoverMethodView
from django.views.generic.base import TemplateView
from django.contrib.auth.decorators import login_required

app_name= 'two_factor_authentication'

urlpatterns = [
    path('otp/login', LoginView.as_view(redirect_authenticated_user=True, authentication_form=OTPAuthenticationForm, template_name="otp_login.html")),
    path('profile/account', login_required(TwoFactorAuthentication.as_view()), name="profile_account"),
    path('profile/account/two-factor-authentication', login_required(RegisterTwoFactorAuthentication.as_view()), name="register_two_factor"),
    path('profile/<deviceid>/qrcode', login_required(qrcode_view), name="user_qrcode"),
   	path('profile/account/disable-two-factor-authentication', login_required(DisableTwoFactorAuthentication.as_view()), name="disable_two_factor"),
   	path('profile/account/two-factor-authentication/method', login_required(RecoverMethodView.as_view()), name="recovery_two_factor"),
]

components/accounts/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser

class User(AbstractUser):
	mobile = models.CharField(max_length=12, null=True)

class UserSecretToken(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    secret_token = models.CharField(max_length=255,null=True)
    is_expired = models.BooleanField(default=False)
    resend_count = models.IntegerField(default=0)
    created_on = models.DateTimeField(auto_now_add=True, null=True)

class UserPasswordHistory(models.Model):
	uid = models.ForeignKey(User, on_delete=models.CASCADE)
	old_password = models.TextField()
	changed_on = models.DateTimeField(auto_now_add=True, null=True)

components/two_factor_authentication/forms.py
from django import forms
from django.core.validators import RegexValidator
from django_otp.forms import OTPAuthenticationForm, OTPTokenForm
from django_otp import devices_for_user
from accounts.models import User
from .models import ChosenRecoveryMethod

class RegisterTwoFactorAuthenticatorForm(forms.Form):
	error_message = {
			'invalid_token': 'Invalid token, please try again',
			'only_numbers': 'Only numbers are allowed',
	}

	pin_code = forms.CharField(validators=[RegexValidator('^[0-9]{6}$', message=error_message.get('only_numbers'))], widget=forms.TextInput(attrs={'class':'form-control', 'autocomplete':'off'}))
	
	def __init__(self, user=None, *args, **kwargs):
		self.user = user
		super(RegisterTwoFactorAuthenticatorForm, self).__init__(*args, **kwargs)
		
	def clean_pin_code(self):
		token = self.cleaned_data.get('pin_code')
		device = self.validate_token(self.user, token)
		if device is None:
			raise forms.ValidationError(self.error_message.get('invalid_token'))
		return token

	def validate_token(self, user, token):
		matches = (device for device in devices_for_user(user, False) if device.verify_token(token))
		return next(matches, None)

class TwoFactorAuthenticatorRecoveryMethodForm(forms.Form):
	error_message = {
			'only_numbers': 'Only numbers are allowed',
			'rec_required': 'Please select recovery method',
			'error': 'something went wronge'
	}
	
	def __init__(self, user=None, *args, **kwargs):
		self.user = user
		super(TwoFactorAuthenticatorRecoveryMethodForm, self).__init__(*args, **kwargs)
		user_email = hasattr(self.user, 'email') and self.user.email or None
		user_mobile = hasattr(self.user, 'mobile') and self.user.mobile or None
		self.choices_1 = 'mobile'
		self.choices_2 = 'email' 
		CHOICES = [
			(self.choices_1, user_mobile), (self.choices_2, user_email)
		]
		self.fields['recovery_method'] = forms.ChoiceField(choices=CHOICES, initial='', widget=forms.RadioSelect(attrs={'class':'form-check-input'}))

	def clean_recovery_method(self):
		recovery_method = self.cleaned_data.get('recovery_method')
		if recovery_method is None:
			raise forms.ValidationError(self.error_message.get('rec_required'))
		return recovery_method

components/accounts/views.py
from django.shortcuts import render
from django.views import View
from django.http import request, HttpResponse, HttpResponseRedirect, JsonResponse
from .forms import LoginForm, UserCreationForm, EditUserProfileForm, ChangePasswordForm, PasswordResetForm, OTPTokenForm
from django.shortcuts import render, redirect, resolve_url
from django.contrib.auth import login, authenticate, update_session_auth_hash, logout
from django.utils.encoding import force_text
from django.utils.http import urlsafe_base64_decode
from .tokens import account_activation_token
from django.contrib import messages
from .models import User, UserSecretToken, UserPasswordHistory
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth import views as auth_views
from django.urls import reverse_lazy
from django.contrib.auth.hashers import (check_password, is_password_usable, make_password,)
from .mails import mail
from django.conf import settings
from . import (
    is_app_installed,
    get_user_chosen_recovery_option,
    get_chosen_option_value,
    decode_chosen_option_value,
    email_option,
    mobile_option,
    get_totp_key,
    send_sms
    )
from binascii import unhexlify

class AccountAuthentication:

    session_name = 'otp'

    def get_user_by_username(self, username):
        user = User.objects.get(username=username)
        return user

class UserCreationView(View):

    def get(self, request):
        if request.user.is_anonymous:
            context = {'registration': UserCreationForm}
            return render(request, template_name='user-registration.html', context=context)
        else:
            return redirect("account:profile")

    def post(self, request):
        form = UserCreationForm(request.POST)
        if form.is_valid():
            user = form.save(commit=False)
            user.is_active = False
            user.save()
            username = form.cleaned_data['username']
            to_email = form.cleaned_data['email']
            if User.objects.filter(username=username).exists():
                if mail.sendEmailVerificationMail(user, request, to_email):
                    #context = {'title':'Account has been created successfully', 'message': 'Thank you. We have sent a verification mail to '+to_email+'. Please check your mail box for further details.'}
                    messages.success(request, 'Account has been created successfully. We have sent a verification mail to '+to_email+'. Please check your mail box for further details.')
                else:
                    messages.error(request, 'Problem in sending email verification.')
                    #context = {'title':'OOPS..!','message': 'Problem in sending email verification .'}
                #return render(request, template_name='message-handler.html', context=context)
                return redirect('account:message_handler')
            else:
                messages.error(request, 'Sorry something went wrong, please try again.')
                #context = {'title':'OOPS..!', 'message': 'Sorry something went wrong, please try again.'}
                #return render(request, template_name='message-handler.html', context=context)
                return redirect('account:message_handler')
        else:
            context = {'registration': form}
            return render(request, template_name="user-registration.html", context=context)

class EditUserProfileView(View):

    def get(self, request):
        editForm = EditUserProfileForm(instance=request.user)
        context = {"edit_profile_form": editForm}
        return render(request, template_name="edit-user-profile.html", context=context)

    def post(self, request):
        edit_form = EditUserProfileForm(request.POST, instance=request.user)
        if edit_form.is_valid():
            user = User.objects.get(id=self.request.user.id)
            to_email = edit_form.cleaned_data['email']
            username = edit_form.cleaned_data['username']
            if to_email != user.email:
                if mail.sendEmailVerificationMail(user, request, to_email):
                    user_profile = edit_form.save(commit=False)
                    user_profile.is_active = False
                    user_profile.save()
                    logout(request)
                    messages.success(request, 'Profile updated successfully. Since you have changed you email address, we have sent a verification mail to '+to_email+'. Please check your mail box for further details. Your account will be on in-active state, until you confirm your updated email address.')
                    return redirect('account:message_handler')
                    #context = {'title':'Your profile has been updated successfully','message': 'Since you have changed you email address, we have sent a verification mail to '+to_email+'. Please check your mail box for further details. Your account will be on in-active state, until you confirm your updated email address'}
                    #return render(request, template_name='message-handler.html', context=context)
            else:
                edit_form.save()
                if user.username != username:
                    user = User.objects.get(id=self.request.user.id)
                    mail.sendUsernameUpdatedMail(user, request, to_email)
                messages.success(request, 'Your profile has been updated successfully.')
                #return HttpResponseRedirect('registration:profile')
                return redirect('account:profile')
                #context = {'title':'Your profile has been updated successfully','message': ''}
                #return render(request, template_name='message-handler.html', context=context)
        else:
            #edit_form = UserProfileEditForm(request.POST)
            context = {"edit_profile_form": edit_form}
            return render(request, template_name="edit-user-profile.html", context=context)

def activate(request, uidb64, token, secret_token):
    try:
        uid = force_text(urlsafe_base64_decode(uidb64))
        user = User.objects.get(pk=uid)
    except(TypeError, ValueError, OverflowError, User.DoesNotExist):
        user = None
    if user is not None and account_activation_token.check_token(user, token) and account_activation_token.check_secret_token(uid, secret_token) and user.is_active == False:
        user.is_active = True
        user.save()
        secret_token = UserSecretToken.objects.get(user_id=uid)
        secret_token.is_expired = True
        secret_token.save()
        #context = {'title':'', 'message':''}
        messages.success(request, 'Thank you, your email address has been confirmed successfully. Now you can login your account.')
        return redirect('account:message_handler')
        #return render(request, template_name='message-handler.html', context=context)
    else:
        messages.error(request,'The email confirm link was invalid, possibly because it has already been used. Please request a new email confimation.')
        return redirect('account:message_handler')
        #context = {'message': 'Invalid Request.'}
        #return render(request, template_name='message-handler.html', context=context)

class ChangePasswordPage(View):

    def get(self, request):
        change_password_form = ChangePasswordForm(request.user)
        context = {'change_password_form': change_password_form}
        return render(request, template_name='change-password.html', context=context)
    
    def post(self, request):
        change_password_form = ChangePasswordForm(request.user, request.POST)
        if change_password_form.is_valid():
            user = change_password_form.save()
            update_session_auth_hash(request, user)
            messages.success(request, 'Password has been changed successfully.')
            return redirect('accounts:profile')
            #return HttpResponseRedirect(reverse('registration:profile'))
        else:
            context = {'change_password_form':change_password_form}
            return render(request, template_name="change-password.html", context=context)

class LoginView(auth_views.LoginView, AccountAuthentication):
    
    form_class = LoginForm
    template_name = 'login.html'
    extra_context = {}
    auth_level = False

    def get_form_class(self):
        if self.request.POST.get('otp_token'):
            self.form_class = OTPTokenForm
            self.auth_level = True
        else:
            self.auth_level = False
        return self.authentication_form or self.form_class

    def form_valid(self, form):
        if self.auth_level and form.cleaned_data['otp_token']:
            user = authenticate(username=self.request.session[self.session_name].get('username'),password=self.request.session[self.session_name].get('password'))
            if user is not None:
                login(self.request, user)
                del self.request.session[self.session_name]
            return HttpResponseRedirect("/")
        else:
            if is_app_installed('django_otp'):
                from django_otp import user_has_device
                user = User.objects.get(username=form.get_user())
                if user_has_device(user):
                    self.request.session[self.session_name] = {'username':form.get_user().username,'password':form.cleaned_data.get('password')}
                    self.form_class = OTPTokenForm
                    return render(self.request, self.template_name, self.get_context_data(first_load=True, username=form.get_user().username))
                else:
                    login(self.request, form.get_user())
                    return HttpResponseRedirect("/")
            else:
                login(self.request, form.get_user())
                return HttpResponseRedirect("/")
    
    def get_success_url(self):
        return reverse_lazy("account:profile")
    success_url = reverse_lazy("account:profile")

    def get_context_data(self, **kwargs):

components/two_factor_authentication/templates/account.html
{% extends 'base.html' %}

{% block content %}
	<div class="row prepend-top-default p-2">
		<div class="col-lg-5 col-md-5 profile-settings-sidebar">
			<h4 class="prepend-top-0"><strong>Two-Factor Authentication</strong></h4>
			<p> Increase your account's security by enabling Two-Factor Authentication (2FA).</p>
		</div>
		<div class="col-lg-7 col-md-7">
			<div class="append-bottom-10">
				{% if messages %}
					<div class="{{ message.tags}} {{ message.extra_tags }}">
						{% for message in messages %}
							<div class="alert alert-success" role="alert">{{ message }}</div>
						{% endfor %}
					</div>
            	{% endif %}
				{% if not enabled %}
					<p>Status: <strong>Disabled</strong></p>
					<a href="{% url 'two_factor_authentication:register_two_factor' %}" class="btn btn-success text-white">Enable two-factor authentication</a>
				{% else %}
					<p>Status: <strong>Enabled</strong></p>
					<a href="{% url 'two_factor_authentication:register_two_factor' %}" class="btn btn-success text-white">Manage two-factor authentication</a>
				{% endif %}
			</div>
		</div>
	</div>
	<hr>
	<div class="row pl-3 pt-2">
		<div class="col-lg-12">
			<p>
				Two-factor authentication (2FA), sometimes referred to as two-step verification or dual-factor authentication, is a security process in which users provide two different authentication factors to verify themselves. This process is done to better protect both the user's credentials and the resources the user can access. Two-factor authentication provides a higher level of security than authentication methods that depend on single-factor authentication (SFA), in which the user provides only one factor -- typically, a password or passcode. Two-factor authentication methods rely on a user providing a password, as well as a second factor, usually either a security token or a biometric factor, such as a fingerprint or facial scan.
			</p>
		</div>
	</div>
{% endblock %}

components/two_factor_authentication/templates/recovery_options.html
{% extends 'base.html' %}

{% load static %}
{% block content %}
<script src="{% static '/two_factor_authentication/js/two_factor_auth.js' %}"></script>
	<div class="row prepend-top-default p-2">
		<div class="col-lg-8">
			{% if messages %}
				<div class="{{ message.tags}} {{ message.extra_tags }}">
					{% for message in messages %}
						<div class="alert alert-success" role="alert">{{ message }}</div>
					{% endfor %}
				</div>
            {% endif %}
            <h1 class="pb-2">Two-Factor Authentication</h1>
			<form action="" accept-charset="UTF-8" method="POST">
				<div class="pb-2">
					<strong>Select any one of the recovery option:</strong>
				</div>
					{% if form and user.is_authenticated %}
						<div class="custom-control custom-switch pb-2">
							{% if user.email %}
								<input type="radio" class="custom-control-input" id="id_recovery_method_1" name="recovery_method" value="email" {% if form.initial.option.chosen_option == form.initial.email_option_name %} checked {% endif %} required>
								  	<label class="custom-control-label" for="id_recovery_method_1">Use my email address - 
								  		<strong>{{ user.email }}</strong>
								  	</label>	
							{% else %}
							<label class="custom-control-label">Inorder to use email address as recovery methods, please <a href="">update email address.</a></label>
							{% endif %}
						</div>
						<div class="custom-control custom-switch pb-2">
						{% if user.mobile %}
							  <input type="radio" class="custom-control-input" id="id_recovery_method_2" name="recovery_method" value="mobile" {% if form.initial.option.chosen_option == form.initial.mobile_option_name %} checked {% endif %} required>
							  	<label class="custom-control-label" for="id_recovery_method_2">Use my mobile number - <strong>{{ user.mobile }}</strong>
							  	</label>
						{% else %}
						<label class="custom-control-label disabled">Inorder to use mobile number as recovery methods, please <a href="">update mobile number.</a></label>
						{% endif %}
						</div>
					{% endif %}
				{{ form.recovery_method.errors }}
				<p class="form-text text-muted hint">
					Is that your old email address or mobile number? Please update you profile.
				</p>
				<p class="form-text text-muted hint">
					If you lose your device you can use any one of these methods to login.
				</p>
				<div class="prepend-top-default">
					<input type="submit" name="commit" value="Update" class="btn btn-success" data-disable-with="Register with two-factor app">
					<a href="{% url 'two_factor_authentication:profile_account' %}" class="btn btn-default">Cancel</a>
				</div>
				{% csrf_token %}
			</form>
		</div>
	</div>
	<hr>
	<div class="row pl-3 pt-2">
		<div class="col-lg-12">
			<p>
				Two-factor authentication (2FA), sometimes referred to as two-step verification or dual-factor authentication, is a security process in which users provide two different authentication factors to verify themselves. This process is done to better protect both the user's credentials and the resources the user can access. Two-factor authentication provides a higher level of security than authentication methods that depend on single-factor authentication (SFA), in which the user provides only one factor -- typically, a password or passcode. Two-factor authentication methods rely on a user providing a password, as well as a second factor, usually either a security token or a biometric factor, such as a fingerprint or facial scan.
			</p>
		</div>
	</div>
{% endblock %}

components/two_factor_authentication/templates/two-factor-authentication.html
{% extends 'base.html' %}

{% load static %}
{% block content %}
<script src="{% static '/two_factor_authentication/js/two_factor_auth.js' %}"></script>
	<div class="row prepend-top-default p-2">
		<div class="col-lg-4 profile-settings-sidebar">
			<h4 class="prepend-top-0"><strong>Register Two-Factor Authenticator</strong></h4>
			<p>Use an one time password authenticator on your mobile device or computer to enable two-factor authentication (2FA)</p>
		</div>
		<div class="col-lg-8">
			{% if messages %}
				<div class="{{ message.tags}} {{ message.extra_tags }}">
					{% for message in messages %}
						<div class="alert alert-success" role="alert">{{ message }}</div>
					{% endfor %}
				</div>
				<p>
					Should you ever lose your phone or access to your one time password secret, each of these recovery codes can be used one time each to regain access to your account. Please save them in a safe place, or you will lose access to your account
				</p>
            {% endif %}
			{% if enabled and not messages %}
			<p>
				You've already enabled two-factor authentication using one time password authenticators. In order to register a different device, you must first disable two-factor authentication.
			</p>
			<p>
				If you lose your device you can change the recovery method for sign-in.
			</p>
			{% elif not enabled %}
				<p>
					Install a soft token authenticator like <a href="https://freeotp.github.io/">FreeOTP</a> or Google Authenticator from your application repository and use that app to scan this QR code. More information is available in the <a href="/help/user/profile/account/two_factor_authentication" target="_blank">documentation</a>.
				</p>
			{% endif %}
			<div class="row">
				{% if not enabled %}
					<div class="col-md-4">
						<img width="220" height="220" src='{% url "two_factor_authentication:user_qrcode" deviceid=device_id %}' onerror="document.getElementById('qrcode').style.display = 'none'; document.getElementById('no-qrcode').style.display = 'block';">
					</div>
					<div class="col-md-8">
						<div class="account-well">
							<p class="prepend-top-0 append-bottom-0">
							Can't scan the code?
							</p>
							<p class="prepend-top-0 append-bottom-0">
							To add the entry manually, provide the following details to the application on your phone.
							</p>
							<p class="prepend-top-0 append-bottom-0">
							Account: golearner:aj.inbusiness@gmail.com
							</p>
							<p class="prepend-top-0 append-bottom-0">
							Key: 7mm7 ghtu nwbt hnz2 of2h rmvb 7vpq e7ui
							</p>
							<p class="two-factor-new-manual-content">
							Time based: Yes
							</p>
						</div>
					</div>
				{% else %}
				<div class="col-md-12">
					<a data-confirm="Are you sure? This will invalidate your registered applications and U2F devices." href="{% url 'two_factor_authentication:disable_two_factor' %}" class="btn btn-danger text-white disable-two-factor">Disable two-factor authentication</a>
					<a href="{% url 'two_factor_authentication:recovery_two_factor' %}" class="btn btn-default recovery-methods">Change Recovery Methods</a>
				</div>
				{% endif %}
			</div>
			{% if not enabled %}
				<form accept-charset="UTF-8" method="POST">
	                {% if form.pin_code.errors %}
	                  <div class="alert alert-danger">
	                      <a class="close" href="#" data-dismiss="alert">×</a>
	                      {{ form.pin_code.errors }}
	                  </div>
	                {% endif %}
					<div class="form-group">
						<label class="label-bold" for="pin_code">Enter the 6-digit code that you see in the app
						</label>
						<input type="text" name="{{ form.pin_code.html_name}}" id="{{ form.pin_code.id_for_label}}"  maxlength=6 value="" class="form-control form-control-md"  autofocus="autofocus" autocomplete="off" required />
					</div>
					<div class="pb-2"><strong>Select any one of the recovery option:</strong></div>
					{% for value, text in rc_form.recovery_method.field.choices %}
							<div class="custom-control custom-switch pb-2">
							{% if text is not None and value is not None %}
							  <input type="radio" class="custom-control-input" id="id_recovery_method_{{ forloop.counter }}" name="{{ rc_form.recovery_method.html_name}}" value="{{ value }}" required>
							  {% if value in "email" %}
							  	<label class="custom-control-label" for="id_recovery_method_{{ forloop.counter }}">Email address - <strong>{{ text }}</strong></label>
							  {% else %}
							  	<label class="custom-control-label" for="id_recovery_method_{{ forloop.counter }}">Mobile number - <strong>{{ text }}</strong></label>
							  {% endif %}
							{% else %}
								{% if value in "email" %}
									<label class="custom-control-label">Inorder to use email address as recovery methods, please <a href="">update email address.</a></label>
								{% else %}
									<label class="custom-control-label disabled">Inorder to use mobile number as recovery methods, please <a href="">update mobile number.</a></label>
								{% endif %}
							{% endif %}
							</div>
					{% endfor %}
					{{ rc_form.recovery_method.errors }}
					<p class="form-text text-muted hint">
						If you lose your device you can use any one of these methods to login.
					</p>
					<div class="prepend-top-default">
						<input type="submit" name="commit" value="Register with two-factor app" class="btn btn-success" data-disable-with="Register with two-factor app">
					</div>
					{% csrf_token %}
				</form>
			{% endif %}
		</div>
	</div>
	<hr>
	<div class="row pl-3 pt-2">
		<div class="col-lg-12">
			<p>
				Two-factor authentication (2FA), sometimes referred to as two-step verification or dual-factor authentication, is a security process in which users provide two different authentication factors to verify themselves. This process is done to better protect both the user's credentials and the resources the user can access. Two-factor authentication provides a higher level of security than authentication methods that depend on single-factor authentication (SFA), in which the user provides only one factor -- typically, a password or passcode. Two-factor authentication methods rely on a user providing a password, as well as a second factor, usually either a security token or a biometric factor, such as a fingerprint or facial scan.
			</p>
		</div>
	</div>
{% endblock %}